## Name

clisp — ANSI Common Lisp compiler, interpreter and debugger.

## Synopsis

`clisp` [[`-h`] | [`--help`]] [`--version`] [`--license`] [`-B `lisp-lib-dir``] #ifdef UNIX [`-K `linking-set``] #endif [`-M `mem-file``] [`-m `mem-size``] #ifdef MULTIMAP_MEMORY_VIA_FILE [`-t `temp-dir``] #endif [`-L `language``] [`-N `locale-dir``] [`-E`domain` `encoding``] [[`-q`] | [`--quiet`] | [`--silent`] | [`-v`] | [`--verbose`]] [`-on-error `action``] [`-repl`] [`-w`] [`-I`] [[`-ansi`] | [`-traditional`]] [`-modern`] [`-p `package``] [`-C`] [`-norc`] [`-i `init-file``...] [`-c` [`-l`] `lisp-file` [`-o `output-file``]...] [`-x `expressions``...] [``lisp-file`` [``argument``...]]

## Description

Invokes the Common Lisp interpreter and compiler. When called without arguments, executes the read-eval-print loop, in which expressions are in turn `READ` from the standard input, `EVAL`uated by the lisp interpreter, and their results are `PRINT`ed to the standard output. Invoked with `-c`, compiles the specified lisp files to a platform-independent bytecode which can be executed more efficiently.

## Options

`-h`
`--help`
  Displays a help message on how to invoke CLISP.
`--version`
  Displays the CLISP version number, as given by the function `LISP-IMPLEMENTATION-VERSION`, the value of the variable `*FEATURES*`, as well some other information.
`--license`
  Displays a summary of the licensing information, the GNU GPL.
`-B` `lisp-lib-dir`
  Specifies the installation directory. This is the directory containing the linking sets and other data files. #ifdef UNIX This option is normally not necessary, because the installation directory is already built-in into the clisp executable. #endif Directory `lisp-lib-dir` can be changed dynamically using the `SYMBOL-MACRO` `*LIB-DIRECTORY*`.
#ifdef UNIX
`-K` `linking-set`

  Specifies the linking set to be run. This is a directory (relative to the `lisp-lib-dir`) containing at least a main executable (runtime) and an initial memory image. Possible values are

  base | the core CLISP
  full | core plus all the modules with which this installation was built, see Section 31.2, “External Modules”.

  The default is base.

#endif
`-M` `mem-file`
  Specifies the initial memory image. This must be a memory dump produced by the `EXT:SAVEINITMEM` function by this clisp runtime. #ifdef UNIX It may have been compressed using GNU gzip. #endif
`-m` `mem-size`

  Sets the amount of memory CLISP tries to grab on startup. The amount may be given as

  `nnnnnnn`
    measured in bytes
  `nnnn` K
  `nnnn` KB
    measured in kilobytes
  `n` M
  `n` MB
    measured in megabytes

  The default is 2 megabytes. #if (oint_addr_len+addr_shift==24) The argument is constrained between 100 KB and 16 MB. #elif (oint_addr_len+addr_shift==26) The argument is constrained between 100 KB and 64 MB. #elif (oint_addr_len+addr_shift==28) The argument is constrained between 100 KB and 256 MB. #else The argument is constrained above 100 KB. #endif

  This version of CLISP #if defined(SPVW_MIXED) && defined(SPVW_BLOCKS) #ifdef GENERATIONAL_GC is not likely to actually use the entire `mem-size` since garbage collection will periodically reduce the amount of used memory. It is therefore common to specify 10 MB even if only 2 MB are going to be used. #else eventually uses the entire `mem-size`. #endif #else allocates memory dynamically. `mem-size` is essentially ignored (except that it determines the Lisp `STACK` size). #endif

#ifdef MULTIMAP_MEMORY_VIA_FILE
`-t` `temp-dir`
  Specifies the directory where the temporary core file is to be held. This option takes precedence over the environment variable `TMPDIR`.
#endif
`-L` `language`

  Specifies the language CLISP uses to communicate with the user. This may be #ifndef GNU_GETTEXT only english. #else one of english, german, french, spanish, dutch, russian, danish. Other languages may be specified through the environment variable `LANG`, provided the corresponding message catalog is installed. #endif The language may be changed dynamically using the `SYMBOL-MACRO` `CUSTOM:*CURRENT-LANGUAGE*`.

`-N` `locale-dir`
  Specifies the base directory of locale files. CLISP will search its message catalogs in ``locale-dir`/`language`/LC_MESSAGES/clisp.mo`. This directory may be changed dynamically using the `SYMBOL-MACRO` `CUSTOM:*CURRENT-LANGUAGE*`.
`-E` `domain` `encoding`

  Specifies the encoding used for the given domain, overriding the default which depends on the environment variables `LC_ALL`, `LC_CTYPE`, `LANG`. `domain` can be

  `file` | affecting `CUSTOM:*DEFAULT-FILE-ENCODING*`
  `pathname` | affecting `CUSTOM:*PATHNAME-ENCODING*`
  `terminal` | affecting `CUSTOM:*TERMINAL-ENCODING*`
  `foreign` | affecting `CUSTOM:*FOREIGN-ENCODING*`
  `misc` | affecting `CUSTOM:*MISC-ENCODING*`
  `blank` | affecting all of the above.

  ### Warning

  Note that the values of these `SYMBOL-MACRO`s that have been saved in a memory image are ignored: these `SYMBOL-MACRO`s are reset based on the OS environment after the memory image is loaded. You have to use the RC file, `CUSTOM:*INIT-HOOKS*` or init function to set them on startup, but it is best to set the aforementioned environment variables appropriately for consistency with other programs. See Section 30.1, “Customizing CLISP Process Initialization and Termination”.

`-q`
`--quiet`
`--silent`
`-v`
`--verbose`
  Change verbosity level: by default, CLISP displays a banner at startup and a good-bye message when quitting, and initializes `*LOAD-VERBOSE*` and `*COMPILE-VERBOSE*` to `T`, and `*LOAD-PRINT*` and `*COMPILE-PRINT*` to `NIL`, as per [ANSI CL standard]. The first `-q` removes the banner and the good-bye message, the second sets variables `*LOAD-VERBOSE*` and `*COMPILE-VERBOSE*` to `NIL`. The first `-v` sets variables `CUSTOM:*REPORT-ERROR-PRINT-BACKTRACE*`, `*LOAD-PRINT*` and `*COMPILE-PRINT*` to `T`, the second sets `CUSTOM:*LOAD-ECHO*` to `T`. These settings affect the output produced by `-i` and `-c` options. Note that these settings persist into the read-eval-print loop. Repeated `-q` and `-v` cancel each other, e.g., `-q -q -v -v -v` is equivalent to `-v`.
`-on-error` `action`

  Override (or force) the batch mode imposed by `-c`, `-x`, and `lisp-file`, depending on `action`:

  appease
    continuable `ERROR`s are turned into `WARNING`s (with `EXT:APPEASE-CERRORS`) other `ERROR`s are handled in the default way
  debug
    `ERROR`s `INVOKE-DEBUGGER` (the normal read-eval-print loop behavior)
  abort
    continuable `ERROR`s are appeased, other `ERROR`s are `ABORT`ed with `EXT:ABORT-ON-ERROR`
  exit
    continuable `ERROR`s are appeased, other `ERROR`s terminate CLISP with `EXT:EXIT-ON-ERROR`

  See also `EXT:SET-GLOBAL-HANDLER`.

`-repl`
  Start an interactive read-eval-print loop after processing the `-c`, `-x`, and `lisp-file` options and on any `ERROR` `SIGNAL`ed during that processing.
`-w`
  Wait for a keypress after program termination.
`-I`

  Interact better with Emacs (useful when running CLISP under Emacs using SLIME, ILISP et al). With this option, CLISP interacts in a way that Emacs can deal with:

  - unnecessary prompts are not suppressed.
  #ifdef GNU_READLINE
  - The GNU readline library treats TAB (see TAB key) as a normal self-inserting character (see Q: A.4.3).
  #endif
`-ansi`
  Comply with the [ANSI CL standard] specification even where CLISP has been traditionally different. It sets the `SYMBOL-MACRO` `CUSTOM:*ANSI*` to `T`.
`-traditional`
  Traditional: reverses the residual effects of `-ansi` in the saved memory image.
`-modern`
  Provides a modern view of symbols: at startup the `*PACKAGE*` variable will be set to the “CS-COMMON-LISP-USER” package, and the `*PRINT-BASE*` will be set to `:DOWNCASE`. This has the effect that symbol lookup is case-sensitive (except for keywords and old-style packages) and that keywords and uninterned symbols are printed with lower-case preferrence.
`-p` `package`
  At startup the value of the variable `*PACKAGE*` will be set to the package named `package`. The default is the value of `*PACKAGE*` when the image was saved, normally “COMMON-LISP-USER”.
`-C`
  Compile when loading: at startup the value of the variable `CUSTOM:*LOAD-COMPILING*` will be set to `T`. Code being `LOAD`ed will then be `COMPILE`d on the fly. This results in slower loading, but faster execution.
`-norc`
  Normally CLISP loads the user “run control” (RC) file on startup (this happens after the `-C` option is processed). The file loaded is `.clisprc.lisp` or `.clisprc.fas` in the home directory `USER-HOMEDIR-PATHNAME`, whichever is newer. This option, `-norc`, prevents loading of the RC file.
`-i` `init-file`
  Specifies initialization files to be `LOAD`ed at startup. These should be lisp files (source or compiled). Several `-i` options can be given; all the specified files will be loaded in order.
`-c` `lisp-file`
  Compiles the specified `lisp-file`s to bytecode (`*.fas`). The compiled files can then be `LOAD`ed instead of the sources to gain efficiency.
`-o` `outputfile`
  Specifies the output file or directory for the compilation of the last specified `lisp-file`.
`-l`
  Produce a bytecode `DISASSEMBLE` listing (`*.lis`) of the files being compiled. Useful only for debugging. See Section 24.1.1, “Function COMPILE-FILE” for details.
`-x` `expressions`
  Executes a series of arbitrary expressions instead of a read-eval-print loop. The values of the expressions will be output to `*STANDARD-OUTPUT*`. Due to the argument processing done by the shell, the `expressions` must be enclosed in double quotes, and double quotes and backslashes must be escaped with backslashes.
`lisp-file` [ `argument` ... ]
  Loads and executes a `lisp-file`, as described in Script execution. There will be no read-eval-print loop. Before `lisp-file` is loaded, the variable `EXT:*ARGS*` will be bound to a list of strings, representing the `argument`s. #ifdef UNIX The first line of `lisp-file` may start with #!, thus permitting CLISP to be used as a script interpreter. #endif If `lisp-file` is -, the `*STANDARD-INPUT*` is used instead of a file. If `lisp-file` is the empty string "" or "--", the normal read-eval-print loop is entered, and the rest of the arguments is still available in `EXT:*ARGS*`, for parsing by the init function of the current memory image. This option must be the last one. No RC file will be executed.

## Language Reference

The language implemented is [ANSI CL standard]. The implementation mostly conforms to the ANSI Common Lisp standard.

## Usage

help
  get context-sensitive on-line help, see Chapter 25, Environment [CLHS-25].
(`APROPOS` `name`)
  list the symbols matching to `name`.
(exit)
(quit)
(bye)
  quit CLISP.
EOF #if defined(UNIX) (Control-D on UNIX) #endif #if defined(WIN32_NATIVE) (Control-Z on Win32) #endif
  leave the current level of the read-eval-print loop (see also Section 1.1, “Special Symbols [CLHS-1.4.1.3]”).
#ifdef GNU_READLINE
arrow keys
  for editing and viewing the input history, using the GNU readline library.
TAB key

  Context sensitive:

  - If you are in the “function position” (in the first symbol after an opening paren or in the first symbol after a `#'`), the completion is limited to the symbols that name functions.
  - If you are in the "filename position" (inside a string after `#P`), the completion is done across file names, bash-style.
  - If you have not typed anything yet, you will get a help message, as if by the Help command.
  - If you have not started typing the next symbol (i.e., you are at a whitespace), the current function or macro is `DESCRIBE`d.
  - Otherwise, the symbol you are currently typing is completed.

#endif

## Files

#ifdef UNIX

clisp
  startup driver (a script or an executable)
#endif #if defined(WIN32_NATIVE)
clisp.exe
  startup driver (executable)
#endif
`lisp.run`
`lisp.exe`
  main executable (runtime)
`lispinit.mem`
  initial memory image
`config.lisp`
  site-dependent configuration (should have been customized before CLISP was built); see Section 30.12, “Customizing CLISP behavior”
`*.lisp`
  lisp source
`*.fas`
  lisp code, compiled by CLISP
`*.lib`
  lisp source library information, generated by `COMPILE-FILE`, see Section 24.1.3, “Function REQUIRE”.
`*.c`
  C code, compiled from lisp source by CLISP (see Section 31.3, “The Foreign Function Call Facility”)

For the CLISP source files, see Chapter 33, The source files of CLISP.

#ifdef HAVE_ENVIRONMENT

## Environment

All environment variables that CLISP uses are read at most once.

`CLISP_LANGUAGE`
  specifies the language CLISP uses to communicate with the user. The legal values are identical to those of the `-L` option which can be used to override this environment variable.
#ifdef UNICODE
`LC_CTYPE`
  specifies the locale which determines the character set in use. The value can be of the form `language` or `language`_`country` or `language`_`country`.`charset`, where `language` is a two-letter ISO 639 language code (lower case), `country` is a two-letter ISO 3166 country code (upper case). `charset` is an optional character set specification, and needs normally not be given because the character set can be inferred from the language and country. This environment variable can be overridden with the `-Edomain encoding` option.
#endif
`LANG`
  specifies the language CLISP uses to communicate with the user, unless it is already specified through the environment variable `CLISP_LANGUAGE` or the `-L` option. #ifdef UNICODE It also specifies the locale determining the character set in use, unless already specified through the environment variable `LC_CTYPE`. #endif The value may begin with a two-letter ISO 639 language code, for example en, de, fr.
#ifdef UNIX
`HOME`
`USER`
  are used for determining the value of the function `USER-HOMEDIR-PATHNAME`.
#endif
`SHELL`
`COMSPEC`
  is used to find the interactive command interpreter called by `EXT:SHELL`.
#ifdef UNIX
`TERM`
  determines the screen size recognized by the pretty printer.
#endif #ifdef MULTIMAP_MEMORY_VIA_FILE
`TMPDIR`
  specifies the directory where the temporary core file is to be held.
#endif
`ORGANIZATION`
  for `SHORT-SITE-NAME` and `LONG-SITE-NAME` in `config.lisp`.
`CLHSROOT`
  for `CUSTOM:CLHS-ROOT` in `config.lisp`.
`IMPNOTES`
  for `CUSTOM:IMPNOTES-ROOT` in `config.lisp`.
`EDITOR`
  for `editor-name` in `config.lisp`.
`LOGICAL_HOST_`host`_FROM`
`LOGICAL_HOST_`host`_TO`
`LOGICAL_HOST_`host``
  for `CUSTOM:*LOAD-LOGICAL-PATHNAME-TRANSLATIONS-DATABASE*`

#endif

## See also

CLISP impnotes, CMU CL - cmucl(1), Emacs - emacs(1), XEmacs - xemacs(1).

## Bugs

When you encounter a bug in CLISP, please report it to the CLISP SourceForge bug tracker.

Before submitting a bug report, please take the following basic steps to make the report more useful:

1. Please do a clean build (remove your build directory and build CLISP with ./configure --build build or at least do a make distclean before make).
2. If you are reporting a “hard crash” (segmentation fault, bus error, core dump etc), please do ./configure --with-debug --build build-g ; cd build-g; gdb lisp.run, then load the appropriate linking set by either base or full gdb command, and report the backtrace (see also Q: A.1.1.9).
3. If you are using pre-built binaries and experience a hard crash, the problem is likely to be in the incompatibilities between the platform on which the binary was built and yours; please try compiling the sources and report the problem if it persists.

When submitting a bug report, please specify the following information:

1. What is your platform (uname -a on a UNIX system)? Compiler version? GNU libc version (on GNU/Linux)?
2. Where did you get the sources or binaries? When? (Absolute dates - like “2006-01-17” - are preferred over the relative ones - like “2 days ago”).
3. How did you build CLISP? (What command, options &c.)
4. What is the output of clisp --version?
5. Please supply the full output (copy and paste) of all the error messages, as well as detailed instructions on how to reproduce them.

Known bugs, some of which may be platform-dependent, include:

#ifdef SPVW_MIXED_BLOCKS

- The memory management scheme is not very flexible.
#endif #ifdef UNIX_COHERENT
- `EXT:*KEYBOARD-INPUT*` does not recognize Control-S and Control-Q.
#endif
- No on-line documentation beyond `APROPOS` and `DESCRIBE` is available.

## Projects

- Write on-line documentation.
- Enhance the compiler so that it can inline local functions.
- Specify a portable set of window and graphics operations.
- Add Multi-Threading capabilities, via OS threads.

## CLISP Authors

CLISP project was started in late 1980-ies by Bruno Haible and Michael Stoll, both in Germany.

See `COPYRIGHT` for the list of other contributors and the license.

| CLISP version 2.38 | Platform: @PLATFORM@ | Last modified: 2006-01-23